#!/usr/bin/env python

import serial
import time

print "DUO PORTABLE CONSOLE"
print "Restarting Arduino UNO."

serialConnection = serial.Serial('/dev/tty.usbmodemfd121', 9600)

serialConnection.timeout = 0.5

# Wait for the microcontroller to restart.
time.sleep(2)

while True:
    while True:
        time.sleep(1)
        hasReadText = False
        while serialConnection.inWaiting() > 0:
            print serialConnection.readline(),
            hasReadText = True
        if not hasReadText:
            break
    print "Please enter a command: list, read, write, or quit."
    command = raw_input("%%% ")
    if command == "list":
        serialConnection.write("l")
    if command == "read":
        print "Please enter a DUO Portable file handle to read."
        fileHandle1 = raw_input("%%% ")
        print "Please enter a local computer file name to write."
        print "Leave blank to only write to console."
        fileName = raw_input("%%% ")
        shouldWriteToFile = (len(fileName) > 0);
        if (shouldWriteToFile):
            fileHandle2 = open(fileName, "w")
        serialConnection.write("r " + fileHandle1)
        while True:
            time.sleep(1)
            hasReadText = False
            while serialConnection.inWaiting() > 0:
                text = serialConnection.readline()
                print text,
                if (shouldWriteToFile):
                    fileHandle2.write(text)
                hasReadText = True
            if not hasReadText:
                break
        if (shouldWriteToFile):
            fileHandle2.close()
    if command == "write":
        print "Please enter a DUO Portable file handle to write."
        fileHandle1 = raw_input("%%% ")
        print "Please enter a local computer file name to read."
        fileName = raw_input("%%% ")
        fileHandle2 = open(fileName, "r")
        text = fileHandle2.read()
        print text
        tempSize = 50
        index = 0
        while index < len(text):
            text2 = text[index:index + tempSize]
            serialConnection.write("w " + fileHandle1 + " " + str(index) + " " + text2)
            while True:
                hasReadText = False
                if serialConnection.inWaiting() > 0:
                    time.sleep(0.3)
                    print serialConnection.readline(),
                    break
            index += tempSize
        fileHandle2.close()
    if command == "quit":
        break



